#include <iostream>
using namespace std;

#include <stdlib.h>
#include <unistd.h>

#include "syssoft_linux.cpp"

volatile long dummy = 0;

class Statistic {
private:
	void print () {
//		o << c << "\t" << min << "\t" << sum/((double) n) << "\t" << max << endl;
//		o.flush();
		n = 0;
		sum = 0.0;
	};
public:
	Statistic ( ostream &p_o, int p_period )
		: o(p_o), period(p_period), c(0), n(0), sum(0.0) {};
	~Statistic () { print(); };

	void update ( double v ) {
		if (n == period) print();
		c++;
		n++;
		sum += v;
		if (n == 1) {
			min = v; max = v;
			return;
		};
		if (v < min) min = v;
		if (v > max) max = v;
	};
private:
	ostream &o;
	int c;
	int period;
	int n;
	double sum;
	double min;
	double max;
};

void main ( int ac, char **av ) {
	if (ac != 2) {
		cerr << "usage: memlock <number of pages>" << endl;
		exit(0);
	}

	long npages = atol(av[1]);
	size_t psize = getpagesize();

	// Now allocate the given number of pages
	char *buffer = new char[npages * psize];

	for (int i=0; i<npages * psize; i++)
		buffer[i] = i % 256;

	Statistic s(cout,10*npages);
	Moment start, stop;

	// ... and try to lock this memory in main memory
	while (1) {
		char *cptr = buffer;
		for (int p=0; p<npages; p++) {
			start.now();
			dummy += *cptr;
			stop.now();
			s.update(stop-start);
			cptr += psize;
		}
	}
}

